<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:cha="http://www.unidic.org/chasen/ns/structure/1.0"
 xmlns:num="http://www.unidic.org/numtrans/ns/structure/1.0"
>

<xsl:output method="xml" encoding="UTF-8" omit-xml-declaration="yes"/>

<xsl:template match="/">
<xsl:apply-templates/>
</xsl:template>

<xsl:template match="text()">
<xsl:call-template name="odoriji_ext">
<xsl:with-param name="text" select="."/>
<xsl:with-param name="loc" select="0"/>
</xsl:call-template>
</xsl:template>

<xsl:template name="odoriji_ext">
    <!-- 原文 -->
    <xsl:param name="text"/>
    <!-- 処理位置 -->
    <xsl:param name="loc"/>
    <xsl:variable name="char" select="substring($text, $loc, 1)"/>
    <xsl:variable name="next_char" select="substring($text, $loc+1, 1)"/>

<xsl:choose>
<xsl:when test="$loc &gt; 1">

    <!-- 処理文字 -->
    <xsl:variable name="pre" select="substring($text, $loc -1, 1)"/>

    <xsl:variable name="pre-daku" select="translate($pre, 'かきくけこさしすせそたちつてとはひふへほカキクケコサシスセソタチツテトハヒフヘホ', 'がぎぐげござじずぜぞだぢづでどばびぶべぼガギグゲゴザジズゼゾダヂヅデドバビブベボ' )"/>
    <xsl:variable name="pre-sei"  select="translate($pre, 'がぎぐげござじずぜぞだぢづでどばびぶべぼガギグゲゴザジズゼゾダヂヅデドバビブベボ', 'かきくけこさしすせそたちつてとはひふへほカキクケコサシスセソタチツテトハヒフヘホ' )"/>

<!-- 文字が踊り字 -->
<xsl:choose>
<xsl:when test="translate('ゝヽ',$char,'') != 'ゝヽ'">
<xsl:value-of select="$pre-sei"/>
</xsl:when>
<xsl:when test="translate('ゞヾ',$char,'') != 'ゞヾ'">
<xsl:value-of select="$pre-daku"/>
</xsl:when>
<!--～～ -->
<xsl:when test="$char = '～' and $next_char = '～'">
<xsl:value-of select="'〳〵'"/>
</xsl:when>
<xsl:when test="$pre = '～' and $char = '～' and $next_char != '～'"></xsl:when>
<!--～゛ -->
<xsl:when test="$char = '～' and $next_char = '゛'">
<xsl:value-of select="'〴〵'"/>
</xsl:when>
<xsl:when test="$pre = '～' and $char = '゛'"></xsl:when>
<!--／＼ -->
<xsl:when test="$char = '／' and $next_char = '＼'">
<xsl:value-of select="'〳〵'"/>
</xsl:when>
<xsl:when test="$pre = '／' and $char = '＼'"></xsl:when>
<!--／゛＼ -->
<xsl:when test="$char = '／' and substring($text, $loc +1 , 2)='゛＼'">
<xsl:value-of select="'〴〵'"/>
</xsl:when>
<xsl:when test="$char = '゛' and $next_char = '＼'">
</xsl:when>
<xsl:when test="$pre = '゛' and $char = '＼'">
</xsl:when>
<xsl:otherwise>
<xsl:value-of select="$char"/>
</xsl:otherwise>
</xsl:choose>

</xsl:when>
<xsl:otherwise>
<xsl:value-of select="$char"/>
</xsl:otherwise>
</xsl:choose>

      <xsl:if test="$loc &lt; string-length($text)">
                <xsl:call-template name="odoriji_ext">
                  <xsl:with-param name="text" select="$text"/>
                  <xsl:with-param name="loc" select="$loc+1"/>
                </xsl:call-template>
      </xsl:if>

</xsl:template>


<xsl:template match="*">
<xsl:copy>
<xsl:for-each select="@*"><xsl:copy /></xsl:for-each>
<xsl:apply-templates/>
</xsl:copy>
</xsl:template>


</xsl:stylesheet>
